// JTLPChgExec.cpp : DLL AvP[Vp̃Gg |Cg`܂B
//

#include "stdafx.h"
#include "JTPlugin.h"
#include "JTAPIWrapper.h"
#include "Config.h"
#include "resource.h"

/* Defines */
#define APP_CLASS_NAME			_T("JTLPChgExec Application Class")
#define APP_TITLE_NAME			_T("JTLPChgExec Application")
#define WM_APPEND_REQUEST		(WM_APP + 1)
#define WM_RELOADCONFIG_REQUEST	(WM_APP + 2)


/* ProtoTypes */
static ATOM				MyRegisterClass	(HINSTANCE, LPTSTR);
static LRESULT CALLBACK	WndProc			(HWND, UINT, WPARAM, LPARAM);


/* Typedefs */
typedef struct _WNDTHREAD_PARAM {
	BOOL	bSuccess;
	HANDLE	hEvent;
} WNDTHREAD_PARAM;

typedef struct _SETTING_ITEM {
	LPWSTR	pKeyName;
	LPWSTR	pDefValue;
	UINT	uiDescription;
} SETTING_ITEM;


/* Global Variables */
static HMODULE	gs_hModule	= NULL;
static HANDLE	gs_hThread	= NULL;

static SETTING_ITEM gs_SettingTbl[] = {
	{APP_ONLS_APP,	L"",	IDS_ONLS_APP	},
	{APP_ONLS_ARGS,	L"",	IDS_ONLS_ARGS	},
	{APP_ONPT_APP,	L"",	IDS_ONPT_APP	},
	{APP_ONPT_ARGS,	L"",	IDS_ONPT_ARGS	},
};


static
BOOL
IsExecutableFile(
	LPTSTR	pFileName	// IN
)
{

#define	EXECUTABLE_SUFFIX	_T(".exe")

	BOOL	bRet;
	DWORD	dwSuffixLen = sizeof(EXECUTABLE_SUFFIX)/sizeof(TCHAR) - 1;

	bRet =  FALSE;

	if (pFileName != NULL) {
		DWORD	dwFilePathLen = _tcslen(pFileName);
		if (dwFilePathLen >= dwSuffixLen) {
			if (_tcsicmp(pFileName + dwFilePathLen - dwSuffixLen, EXECUTABLE_SUFFIX) == 0) {
				bRet = TRUE;
			}
		}
	}

	return bRet;
}

static
BOOL
ExecUserAction(
	LPTSTR	pAppPath,
	LPTSTR	pArgs
)
{
	BOOL	bRet;

	bRet = FALSE;	// default return value

	if (pAppPath == NULL) {
		return FALSE;
	}

	if (IsExecutableFile(pAppPath)) {

		PROCESS_INFORMATION pi;

		memset(&pi, 0, sizeof(pi));

		bRet = CreateProcess(pAppPath, pArgs, NULL, NULL, FALSE, 0, NULL, NULL, NULL, &pi);

		if (bRet) {
			CloseHandle(pi.hThread);
			CloseHandle(pi.hProcess);
		}

	}
	else {
		SHELLEXECUTEINFO	sei;

		ZeroMemory(&sei, sizeof(SHELLEXECUTEINFO));

		sei.cbSize = sizeof(sei);
		sei.lpVerb = _T("Open");
		sei.lpFile = pAppPath;

		bRet = ShellExecuteEx(&sei);
	}


	return bRet;
}

static
ATOM
MyRegisterClass(
	HINSTANCE	hInstance,
	LPTSTR		szWindowClass
)
{
	WNDCLASS	wc;

    wc.style			= 0;
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= 0;
    wc.hCursor			= 0;
    wc.hbrBackground	= 0;
    wc.lpszMenuName		= 0;
    wc.lpszClassName	= szWindowClass;

	return RegisterClass(&wc);
}

static
BOOL
IsLandscape()
{
	int		nWidth;
	int		nHeight;
	BOOL	bRet;

	bRet = FALSE;

	nWidth = GetSystemMetrics(SM_CXSCREEN);
	nHeight = GetSystemMetrics(SM_CYSCREEN);

	if (nWidth > nHeight) {
		bRet = TRUE;
	}

	return bRet;
}

static
LRESULT
CALLBACK
WndProc(
	HWND	hWnd,
	UINT	message,
	WPARAM	wParam,
	LPARAM	lParam
)
{
	static BOOL			s_bLandscape = FALSE;
	static CONFIGDATA	s_configData;

	switch (message) 
	{
		case WM_CREATE:
			{
				memset(&s_configData, 0, sizeof(s_configData));
				LoadConfigData(&s_configData);

				s_bLandscape = IsLandscape();
			}
			break;

		case WM_DESTROY:
			DiscardConfigData(&s_configData);
			PostQuitMessage(0);
     		break;

		case WM_SETTINGCHANGE:
			if (wParam == SETTINGCHANGE_RESET) {
				BOOL	bNewLandscape;

				bNewLandscape = IsLandscape();
				if (s_bLandscape) {
					if (!bNewLandscape) {
						//  -> c
						if (s_configData.pOnPortraitApp != NULL && _tcslen(s_configData.pOnPortraitApp) != 0) {
							ExecUserAction(s_configData.pOnPortraitApp, s_configData.pOnPortraitArgs);
						}
					}
				}
				else {
					if (bNewLandscape) {
						// c -> 
						if (s_configData.pOnLandscapeApp != NULL && _tcslen(s_configData.pOnLandscapeApp) != 0) {
							ExecUserAction(s_configData.pOnLandscapeApp, s_configData.pOnLandscapeArgs);
						}
					}
				}

				s_bLandscape = bNewLandscape;
			}
     		break;

		case WM_APPEND_REQUEST:
			DestroyWindow(hWnd);
			break;

		case WM_RELOADCONFIG_REQUEST:
			{
				DiscardConfigData(&s_configData);
				LoadConfigData(&s_configData);
			}
			break;

		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }

   return 0;
}


static
DWORD
WINAPI
WindowThread(void* pParam)
{
	if (pParam != NULL) {
		HWND	hWnd;
		WNDTHREAD_PARAM* pThreadParam;
		
		pThreadParam = (WNDTHREAD_PARAM*)pParam;

		MyRegisterClass(gs_hModule, APP_CLASS_NAME);

		hWnd = CreateWindow(APP_CLASS_NAME, APP_TITLE_NAME, 0, 0, 0, 0, 0, NULL, NULL, gs_hModule, NULL);

		if (hWnd != NULL) {
			MSG		msg;

			pThreadParam->bSuccess = TRUE;
			SetEvent(pThreadParam->hEvent);

			while (GetMessage(&msg, hWnd, 0, 0)) {
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
		else {
			pThreadParam->bSuccess = FALSE;
			SetEvent(pThreadParam->hEvent);
		}
	}

	return 0;
}

static
void
CleanupWindowThread()
{
	if (gs_hThread != NULL) {
		HWND	hWnd = NULL;

		hWnd = FindWindow(APP_CLASS_NAME, APP_TITLE_NAME);
		if (hWnd != NULL) {
			PostMessage(hWnd, WM_APPEND_REQUEST, 0, 0);
		}

		WaitForSingleObject(gs_hThread, INFINITE);
		CloseHandle(gs_hThread);
		gs_hThread = NULL;

		JTAPIWrap_Terminate();
	}
}

BOOL
APIENTRY
DllMain(
	HANDLE hModule, 
	DWORD  ul_reason_for_call, 
	LPVOID lpReserved
)
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		gs_hModule = (HMODULE)hModule;
		break;
	case DLL_PROCESS_DETACH:
		CleanupWindowThread();
		gs_hModule = NULL;
		break;
	}
    return TRUE;
}


DLLEXPORT
DWORD
JTEvent_PermitSpecVersion()
{
	return MAKEVERSION(MAJOR, MINOR, BUILD, REVISION);
}


DLLEXPORT
BOOL
JTEvent_Init(
	HMODULE	hJoeTune
)
{
	BOOL	bRet;
	HWND	hWnd;

	bRet = FALSE;
	
	if (hJoeTune == NULL) {
		return FALSE;
	}

	hWnd = FindWindow(APP_CLASS_NAME, APP_TITLE_NAME);
	if (hWnd == NULL) {
		if (gs_hThread == NULL) {
			if (JTAPIWrap_Initialize(hJoeTune, gs_hModule)) {

				WNDTHREAD_PARAM	param;

				memset(&param, 0, sizeof(param));
				param.bSuccess	= FALSE;
				param.hEvent	= CreateEvent(NULL, FALSE, FALSE, NULL);

				if (param.hEvent != NULL) {
					HANDLE			hThread;
					DWORD			dwThreadID;

					hThread = (HANDLE)CreateThread(NULL, 0, WindowThread, &param, 0, &dwThreadID);
					if (hThread != NULL) {
						WaitForSingleObject(param.hEvent, INFINITE);
						CloseHandle(param.hEvent);
						param.hEvent = NULL;

						if (param.bSuccess) {
							gs_hThread = hThread;
							bRet = TRUE;
						}
						else {
							WaitForSingleObject(hThread, INFINITE);
							CloseHandle(hThread);
							hThread = NULL;

							JTAPIWrap_Terminate();
						}
					}
					else {
						CloseHandle(param.hEvent);
						param.hEvent = NULL;

						JTAPIWrap_Terminate();
					}
				}
				else {
					JTAPIWrap_Terminate();
				}
			}
		}
	}

	return bRet;
}

DLLEXPORT
void
JTEvent_Close()
{
	CleanupWindowThread();
}

DLLEXPORT
DWORD
JTEvent_GetSettingsCount()
{
	return sizeof(gs_SettingTbl)/sizeof(gs_SettingTbl[0]);
}

DLLEXPORT
void
JTEvent_GetSettingsInfo(
	SETTINGSINFO *settingsList
)
{
	int	i;

	for (i = 0; i < sizeof(gs_SettingTbl)/sizeof(gs_SettingTbl[0]); i++) {
		wcscpy(settingsList[i].keyName,		gs_SettingTbl[i].pKeyName);
		wcscpy(settingsList[i].defValue,	gs_SettingTbl[i].pDefValue);
		LoadString(gs_hModule, gs_SettingTbl[i].uiDescription, settingsList[i].description, MAX_BUFFER);
	}
}
